#include <stdio.h>
#include <time.h>
#include "sem.h"

static char *xtime(time_t *bt)
{
  static char buf[256];
  struct tm *lt, *localtime();

  lt = localtime(bt);
  
  sprintf(buf, "%02d%02d%02d-%02d:%02d:%02d",
	  lt->tm_year, lt->tm_mon, lt->tm_mday,
	  lt->tm_hour, lt->tm_min, lt->tm_sec);

  return buf;
}

main()
{
  int i;
  struct semid_ds buf;
  extern char *ctime();

  puts("Id  Uid/Gid  Cuid/Cgid   Mode\tKey\tLen  Otime            Ctime");
  for (i = 0; i < 255; i++)
    if (sem_stat(i, &buf) != -1)
    {
      printf("%-3d %3d/%-3d   %3d/%-3d   %06o\t%d\t%-3d  ",
	     i,
	     buf.sem_perm.uid, buf.sem_perm.gid,
	     buf.sem_perm.cuid, buf.sem_perm.cgid,
	     buf.sem_perm.mode, buf.sem_perm.key,
	     buf.sem_nsems);
      if (buf.sem_otime)
	printf("%s  ", xtime(&buf.sem_otime));
      else
	printf("{never}          ");

      if (buf.sem_ctime)
	printf("%s", xtime(&buf.sem_ctime));
      else
	printf("{never}");
      putchar('\n');
    }
}
